﻿--    __              __
--   /__|            /__\
--  //   __        / /  \ \
-- ||   |_ |uild  | |    | |rg
--  \\___//        \ \__/ /
--   \___/           \__/       Version III.O
-- Updated by Deerah of Illidan
-- Originally Created by Sardonic, Server: Garona
-- Thanks to the creator of WantAds and CTmod, Sardonic pillaged your code.
-- Also thanks to Blizzard for their ever changing code...

--------------------
-- Variables
--------------------

---- Constants -----
GO_GUILDMEMBERS_TO_DISPLAY = 19;        --Default 19; Maximum number of guild memebers to display at one time
GO_FRAME_HEIGHT = 16;					--Default 16; Used by scrolling mechanism, is the height of each charecter button.

------ Saved -------
go_HideButton = 0;                      --Default 0; 0 if mini map button is shown, 1 if hidden
go_PrivateToggle = "PNote";              --Default "PNote"; Private tab name
go_PublicToggle = "Note";               --Default "Note"; Public tab name
go_ShowOfflineMembers = 1;              --Default 1; 0 if offline members are not shown, 1 if they are
go_SortType = "Name";					--Default "Name"; Which column to sort by?
go_Skin = "Onyxia";						--Default "Onyxia"; GuildOrg Skin, will be used to set the skin you want in the future

---- Temporary -----
go_Window_Open = 0;                     --0 if GuildOrg window not shown, 1 if shown
go_Debug = 0;                           --0 if debugging text is disabled, 1 if enabled
go_RunAtStart = 0;						--0 if the special stuff has not been run, 1 if it has
go_Variables_Loaded = 0;                --0 if variables have not been loaded, 1 if loaded
go_NumAlts = 0;                         --Number of alts online
go_NumAltsTotal=0;						--Number of alts in guild
go_NumOnline = 0;                       --Number of members online
go_numGuildMembers = 0;                 --Number of total members
go_ReverseSort = 0;						--1 means do a reverse sort, 0 a normal.
go_Realm = "None";                      --Current realm name
go_guildName = "None";					--Player's current guild
go_time = math.floor(GetTime());        --Used to prevent any Stack Overflows when GUILD_ROSTER_UPDATE is fired too fast
go_BeingDragged = false;                --If the window is being dragged
go_inGuild = 2;							--If player is in guild, then it is set to 1, if not then it is set to 0

------ Lists -------
go_RealmRef = {};                       --The table with the different realms that are used (you have been on)
go_GuildList = {};                    	--The table with the different guilds that are used (you have been in)
go_MemberList = {};						--The table that contains the different guild members
go_Reference = {};						--Table that contains the different guilds and realms that have entries in the go_RealmRef list
GuildOrgCP_CheckStates = {              --The different Control Panel settings
    hide = 0, 							--Default 0; Hide GuildOrg minimap icon; 0 no, 1 yes
	alt_click = 1, 						--Default 1; Alt click to whisper person; 0 no, 1 yes
	shift_click = 1, 					--Default 1; Shift click to invite person to party/raid; 0 no, 1 yes
	ctrl_click = 1,						--Default 1; Ctrl click to insert player's name into either the chat box or GuildOrg edit box; 0 no, 1 yes
	auto_officer = 0, 					--Default 0; Auto combine using officer notes; 0 no, 1 yes
	auto_public = 0};					--Default 0; Auto combine using public notes; 0 no, 1 yes

-- Popup Dialogs ---
StaticPopupDialogs["GUILDORG_CONFIRM_DELETE"] = {
	text = "Do you really want to kick these members?",
  	button1 = "Yes, murder them.",
  	button2 = "No, I'm sorry.",
  	OnAccept = function()
  		GuildOrg_Debug("Idiot... they were good members!","green");
		GuildOrg_Delete_Player();
  	end,
	OnCancel = function()
		GuildOrg_Debug("You wimp, KICK THEM!!!","red");
		GuildOrg_ClearChecks();
	end,
  	timeout = 0,
  	whileDead = 1,
  	hideOnEscape = 1};



--------------------
-- Bindings
--------------------
	BINDING_HEADER_GUILDORG = "Guild Organizer";
	BINDING_NAME_GUILDORG_TOGGLE = "Toggle GuildOrg List";
	BINDING_NAME_GUILDORG_CP = "Toggle GuildOrg Control Panel";


function GuildOrg_Initialize()
--------------------
-- Registers this on Initialization
--------------------

    this:RegisterForDrag("LeftButton");
    this:RegisterEvent("VARIABLES_LOADED");
    this:RegisterEvent("GUILD_ROSTER_UPDATE");
	this:RegisterEvent("PLAYER_GUILD_UPDATE");
	this:RegisterEvent("GUILD_MOTD");
    
    SLASH_GUILDORG1 = "/guildorg";
    SLASH_GUILDORG2 = "/go";
    
    SlashCmdList["GUILDORG"] =
    
        function(msg)
        local arg1 = gsub(msg, "%s*([^%s]+).*", "%1");
        GuildOrg_SlashHandler(arg1);
    end
end


function GuildOrg_OnEvent()
--------------------
-- Called by the UI when an event we've registered for occurs.
--------------------

    if(event == "GUILD_ROSTER_UPDATE") then
		if(math.floor(GetTime())>go_time)then
			GuildOrg_Debug("GUILD_ROSTER_UPDATE v="..go_Variables_Loaded.." in="..go_inGuild,"white");
			GuildOrg_LoadTable()
			go_time=math.floor(GetTime());
			if(go_Variables_Loaded == 1 and go_inGuild == 1) then
				if(go_Window_Open==1)then 
					GuildOrg_UpdateMemberTable();
					GuildOrg_Update();
				else
					GuildOrg_UpdateMemberTable();
            	end
        	end
		end      
    elseif(event == "PLAYER_GUILD_UPDATE") then
		GuildOrg_Debug("PLAYER_GUILD_UPDATE v="..go_Variables_Loaded.." in="..go_inGuild,"white");
		GuildOrg_LoadTable()
		if(go_Variables_Loaded == 1 and go_inGuild == 1) then
			GuildOrg_UpdateMemberTable();
			GuildOrg_Update();
        end
    elseif(event == "GUILD_MOTD") then
        GuildOrg_Debug("GUILD_MOTD v="..go_Variables_Loaded.." in="..go_inGuild,"white");
		if(go_Variables_Loaded == 1 and go_inGuild == 1) then
			GuildOrg_DrawMOTD();
		end
    elseif(event == "VARIABLES_LOADED") then
    	GuildOrg_Debug("VARIABLES_LOADED v="..go_Variables_Loaded.." in="..go_inGuild,"white");
		GuildRoster();
		go_Variables_Loaded = 1;
        go_Realm = GetRealmName();
		GuildOrgCP_Init();
		GuildOrg_LoadTable()
    end
end


function GuildOrg_LoadTable()
--------------------
-- Called to update the table and rest of the data, if you arent in the guild this will hopefully
-- prevent you from errors.
--------------------

	go_guildName = GetGuildInfo("player");
	if(IsInGuild()==1 and go_inGuild == (0 or 2) and go_guildName ~= nil)then
		GuildOrg_Print("Loading GuildOrg for server "..go_Realm,0,1,0);
		go_inGuild = 1;
		if(GuildOrg_ReferenceCheck())then
			GuildOrg_Debug("Reference found","green");
		else
			GuildOrg_Debug("New reference created","yellow");
		end
		if(go_RealmRef[go_Realm] == nil) then
			go_RealmRef[go_Realm] = {};
			go_RealmRef[go_Realm].go_GuildList = {};
			go_RealmRef[go_Realm].go_GuildList[go_guildName] = {};
			go_RealmRef[go_Realm].go_GuildList["-1"] = {};
			go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList = {};
			go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList = {};
			GuildOrg_Print("Realm list nil, creating new list...",0,1,0);
			GuildOrg_NewList();
		elseif(go_RealmRef[go_Realm].go_GuildList[go_guildName] == nil)then
			go_RealmRef[go_Realm].go_GuildList[go_guildName] = {};
			go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList = {};
			GuildOrg_Print("Realm guild list nil, creating new list...",0,1,0);
			GuildOrg_NewList();
		end
		if(go_RealmRef[go_Realm].go_GuildList["-1"] == nil)then
			go_RealmRef[go_Realm].go_GuildList["-1"] = {};
			go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList = {};
		end
        if(go_HideButton == 1) then
			GuildOrg_ButtonFrame:Hide();
		else
			GuildOrg_ButtonFrame:Show();
		end
		GuildOrg_UpdateMemberTable();
    	GuildOrg_DrawMOTD();
		GuildOrg_Update();
	elseif(go_inGuild == (2 or 1))then
		go_inGuild = 0;
		GuildOrg_Debug("Not in guild.");
		GuildOrg_ButtonFrame:Hide();
	end
end


function GuildOrg_ReferenceCheck()
--------------------
-- Checks the reference table and sees if the current realm and guild is in it.
-- This will be used in the future to allow the viewing of a different guild 
-- that you have seen.
--------------------

	local i = table.getn(go_Reference);
	for t=1,i,1 do
		if(go_Reference[t].r_realm_name==go_Realm)then
			if(go_Reference[t].r_guild_name==go_guildName)then
				return true;
			end
		end
	end
	local go_new_reference = {r_realm_name = go_Realm, r_guild_name = go_guildName};
	table.insert(go_Reference,go_new_reference);
	return false;
end


function GuildOrg_CP_Get(option)
--------------------
-- Gets the CheckStates of the option
--------------------

	return GuildOrgCP_CheckStates[option];
end


function GuildOrg_CP_set(option, value)
--------------------
-- Sets the CheckStates of an option to the stated value
--------------------

	if(option == "go_HideButton") then
		go_HideButton = value;
		if(value == 1) then
			GuildOrg_ButtonFrame:Hide();
		else
			GuildOrg_ButtonFrame:Show();
		end
	else
		GuildOrgCP_CheckStates[option] = value;
	end
end


function GuildOrg_SlashHandler(msg)
--------------------
-- Handles Slash commands
--------------------

    if(msg == "button" and go_inGuild == 1) then
		if(go_HideButton == 0) then
			GuildOrg_ButtonFrame:Hide();
			go_HideButton = 1;
		else
			GuildOrg_ButtonFrame:Show();
			go_HideButton = 0;
		end
    elseif(msg == "window" and go_inGuild == 1) then
		GuildOrg_Toggle();
	elseif(msg == "control" and go_inGuild == 1) then
		GuildOrgCompassOnclick("RightButton");
	elseif(msg == "delete-guild-data" and go_inGuild == 1)then
		GuildOrg_DeleteGuildData();
		GuildOrg_Print("All the current guild data has been deleted, list will rebuild momentarily.",1,1,0);
	elseif(msg == "delete-all-data") then
		for i=1,table.getn(go_Reference),1 do
			GuildOrg_Debug("Removing Guild "..go_Reference[i].r_guild_name.." on "..go_Reference[i].r_realm_name..", then clearing the \"-1\" guild list for that server.","black");
			GuildOrg_DeleteGuildData(go_Reference[i].r_realm_name,go_Reference[i].r_guild_name);
			GuildOrg_DeleteGuildData(go_Reference[i].r_realm_name,"-1");
		end
		GuildOrg_Print("All the guild data has been deleted, list for your current guild will rebuild momentarily.",1,1,0);
    elseif(msg == "debug") then
		if(go_Debug == 0)then
			go_Debug=1;
            GuildOrg_Print("Debug On",0,1,0);
		else
		    go_Debug=0;
            GuildOrg_Print("Debug Off",1,0,0);
		end
	elseif(msg == "about") then
		GuildOrg_Print("Guild Organizer version 3.0");
		GuildOrg_Print("Updated by Deerah of Illidan",0,1,1);
		GuildOrg_Print("Originally created by Sardonic, Server: Garona",0,1,1);
		GuildOrg_Debug("Debug mode is on... let the spammage ensue!","green");
    elseif(go_inGuild == 1)then
		GuildOrg_Print("Usage:");
		GuildOrg_Print("  /go about",1,0,1);
		GuildOrg_Print("      Displays AddOn information.");		
		GuildOrg_Print("  /go button",1,0,1);
		GuildOrg_Print("      Hide/Show the GuildOrg compass button.");
		GuildOrg_Print("  /go control",1,0,1);
		GuildOrg_Print("      Open/Close the GuildOrg control panel.");
		GuildOrg_Print("  /go delete-guild-data",1,0,1);
		GuildOrg_Print("      Deletes your GuildOrg data for the current guild. (Warning: private notes and all main<->alt associations will be lost!)");
		GuildOrg_Print("  /go delete-all-data",1,0,1);
		GuildOrg_Print("      Deletes all your guild data for any guild saved in the file. (Warning: private notes and all main<->alt associations will be lost!)");
		GuildOrg_Print("  /go window",1,0,1);
		GuildOrg_Print("      Open/Close the GuildOrg main window.");
	else
		GuildOrg_Print("Not in guild, commands limited.",1,0,0);
		GuildOrg_Print("Usage:");
		GuildOrg_Print("  /go about",1,0,1);
		GuildOrg_Print("      Displays AddOn information.");
		GuildOrg_Print("  /go delete-all-data",1,0,1);
		GuildOrg_Print("      Deletes all your guild data for any guild saved in the file. (Warning: private notes and all main<->alt associations will be lost!)");
	end
end


function LastOnlineText(guildIndex)
--------------------
-- Returns the correct text to put in the "Last Online" column.
-- Expects you to supply the real guild index number of the player in question.
--------------------
    
----GuildOrg_Debug("Player last online number "..guildIndex);
	local year, month, day, hour = GetGuildRosterLastOnline(guildIndex);
	if ( (year == 0) or (year == nil) ) then
		if ( (month == 0) or (month == nil) ) then
			if ( (day == 0) or (day == nil) ) then
				if ( (hour == 0) or (hour == nil) ) then
					return LASTONLINE_MINS;
				else
					return format(GetText("LASTONLINE_HOURS", nil, hour), hour);
				end
          	else
				return	format(GetText("LASTONLINE_DAYS", nil, day), day);
			end
		else
			return format(GetText("LASTONLINE_MONTHS", nil, month), month);
		end
	else
		return format(GetText("LASTONLINE_YEARS", nil, year), year);
	end
	return "Not Found";
end


function GuildOrg_Print(msg, r, g, b)
--------------------
-- Prints to default chat frame
--------------------

    -- If no r,g,b; make each 1
	if ( not r ) then r=1.0; end;
	if ( not g ) then g=1.0; end;
	if ( not b ) then b=1.0; end;
	DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
end


function GuildOrg_Debug(msg, color)
--------------------
-- Debugging text handler
--------------------

	if(go_Debug==1)then
        if(color=="red")then
            GuildOrg_Print(msg,1,0,0)
        elseif(color=="green")then
            GuildOrg_Print(msg,0,1,0)
        elseif(color=="blue")then
            GuildOrg_Print(msg,0,0,1)
        elseif(color=="purple" or color=="magenta")then
            GuildOrg_Print(msg,1,0,1)
		elseif(color=="white")then
			GuildOrg_Print(msg,1,1,1)
		elseif(color=="black")then
			GuildOrg_Print(msg,0,0,0)
		elseif(color=="yellow")then
			GuildOrg_Print(msg,1,1,0)
		elseif(color=="light blue" or color=="cyan")then
			GuildOrg_Print(msg,0,1,1)
        else
            GuildOrg_Print(msg,.5,.5,0)
        end
	end
end


--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------   GuildOrg Frame Section   --------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

-- GuildOrg_OnShow()        			--Called when the GuildOrg window is shown.
-- GuildOrg_Toggle()        			--Called to Open/Close the GuildOrg window.
-- GuildOrg_OnDragStart()   			--Called to start dragging the GuildOrg window.
-- GuildOrg_OnDragStop()				--Called to stop dragging the GuildOrg window.
-- GuildOrg_FrameColumn_SetWidth(width)	--Called to set the width of the column that called it.
-- GuildOrg_Sort()						--Called to sort the columns.
-- SetGuildOrgShowOffline()				--Called to set the show offline button.
-- GuildOrg_UpdateCount()				--Called to update the number of guild members on and number of guild members in guild.
-- GuildOrg_SetSortType(go_type)		--Called to set the sorting type.
-- GuildOrg_DrawMOTD()					--Called to draw the MOTD.
-- GuildOrg_Update()					--Called to draw the guild list to the window (and update the list).

function GuildOrg_OnShow()
--------------------
-- Executed when Guild Organizer window is shown to the user
--------------------

GuildOrg_Debug("On GuildOrg Show");
    GuildOrg_DrawMOTD();
    if(go_ShowOfflineMembers==1)then
        GuildOrgOfflineButton:SetChecked(true);
    else
        GuildOrgOfflineButton:SetChecked(false);
    end
    --update the variable tabs to properly show
	if(go_PublicToggle == "Officer") then		
    	if(CanViewOfficerNote())then
			GuildOrgFrameColumnHeader6:SetText("Officer Note");
		else
			go_PublicToggle = "Note";		
			GuildOrgFrameColumnHeader6:SetText("Public Note");
		end
    elseif(go_PublicToggle == "Note") then		
		GuildOrgFrameColumnHeader6:SetText("Public Note");
	elseif(go_PublicToggle == "Last Online") then
		GuildOrgFrameColumnHeader6:SetText("Last Online");
	else
		GuildOrgFrameColumnHeader6:SetText("Rank");
	end
    if(go_PrivateToggle == "Officer") then
	    if(CanViewOfficerNote())then
			GuildOrgFrameColumnHeader7:SetText("Officer Note");
		else
			go_PrivateToggle = "PNote";		
			GuildOrgFrameColumnHeader7:SetText("Private Note");
		end
	elseif(go_PrivateToggle == "PNote") then		
		GuildOrgFrameColumnHeader7:SetText("Private Note");
	elseif(go_PrivateToggle == "Last Online") then
		GuildOrgFrameColumnHeader7:SetText("Last Online");
	else
		GuildOrgFrameColumnHeader7:SetText("Rank");
	end
	--sort the list according to the last sort
	GuildOrg_Sort();
	GuildOrg_UpdateMemberTable();
	GuildOrg_Update();
end


function GuildOrg_Toggle()
--------------------
-- Hides/Unhides Guild Organizer Window.
--------------------

GuildOrg_Debug("Hide/Show GuildOrg window");
	 if ( GuildOrg:IsVisible() ) then
 		GuildOrg:Hide();
 		go_Window_Open = 0;
 	else
 		GuildOrg:Show();
 		go_Window_Open = 1;
 	end
end


function GuildOrg_OnDragStart()
--------------------
-- Frame dragging start
--------------------

GuildOrg_Debug("Start Drag");
	if (not go_BeingDragged) then
		this:StartMoving();
		go_BeingDragged = true;
	end
end

function GuildOrg_OnDragStop()
--------------------
-- Frame dragging finish
--------------------

GuildOrg_Debug("Stop Drag");
	if (go_BeingDragged) then
		this:StopMovingOrSizing()
		go_BeingDragged = false;
	end
end


function GuildOrg_FrameColumn_SetWidth(width)
--------------------
-- Sets the Column Width for each column in the guild display
--------------------

GuildOrg_Debug("Set Column width "..width);
    getglobal(this:GetName()):SetWidth(width);
 	getglobal(this:GetName().."Middle"):SetWidth(width - 9);
end


function GuildOrg_Sort()
--------------------
-- This function will sort the guild list and update the view
--------------------
	
GuildOrg_Debug("Sort List");
	if(go_RealmRef[go_Realm].go_GuildList[go_guildName] ~=nil) then
		local tmp_ref = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList;
		table.sort( go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList, GuildOrgPredicate);
	end
	GuildOrg_Update();
end


function GuildOrgPredicate(lhs, rhs)
--------------------
-- Copied from wantads and reworked. Used by the table.sort
-- lua function to determine which of two GuildList elements goes first.
--------------------

	if (lhs == nil) then
        if (rhs == nil) then
            return false;
        else
            return true;
        end
    elseif (rhs == nil) then
        return false;
    end

	if(go_ReverseSort == 0) then
		if(go_SortType == "Name") then
			if(lhs.f_name < rhs.f_name) then
				return true;
			elseif (rhs.f_name < lhs.f_name) then
				return false;
			end
		elseif(go_SortType == "Alts") then
			if(lhs.f_alt < rhs.f_alt) then
				return true;
			elseif (rhs.f_alt < lhs.f_alt) then
			   return false;
			end
		elseif(go_SortType == "Lvl") then
		    if(lhs.f_lvl < rhs.f_lvl) then
				return true;
		    elseif (rhs.f_lvl < lhs.f_lvl) then
			  return false;
		    end
		elseif(go_SortType  == "Class") then
		    if(lhs.f_class < rhs.f_class) then
				return true;
		    elseif (rhs.f_class < lhs.f_class) then
			  return false;
		    end
		elseif(go_SortType  == "Zone") then
		    if(lhs.f_zone < rhs.f_zone) then
				return true;
		    elseif (rhs.f_zone < lhs.f_zone) then
			  return false;
		    end
		elseif(go_SortType  == "Note") then
		    if(lhs.f_note < rhs.f_note) then
				return true;
		    elseif (rhs.f_note < lhs.f_note) then
			  return false;
		    end
		elseif(go_SortType  == "PNote") then
		    if(lhs.f_p_note < rhs.f_p_note) then
				return true;
		    elseif (rhs.f_p_note < lhs.f_p_note) then
				return false;
		    end
		elseif(go_SortType  == "Rank") then
		    if(lhs.f_rankIndex > rhs.f_rankIndex) then
				return true;
		    elseif (rhs.f_rankIndex > lhs.f_rankIndex) then
				return false;
		    end
		elseif(go_SortType == "Last Online") then
			lhs.year, lhs.month, lhs.day, lhs.hour = GetGuildRosterLastOnline(lhs.f_id);	
			rhs.year, rhs.month, rhs.day, rhs.hour = GetGuildRosterLastOnline(rhs.f_id);
			----GuildOrg_Debug("LHS years: "..tostring(lhs.year).." months "..tostring(lhs.month).." days "..tostring(lhs.day).." hours "..tostring(lhs.hour).." online "..tostring(lhs.f_online));
			----GuildOrg_Debug("RHS years: "..tostring(rhs.year).." months "..tostring(rhs.month).." days "..tostring(rhs.day).." hours "..tostring(rhs.hour).." online "..tostring(rhs.f_online));
			if((lhs.f_online == nil) and rhs.f_online) then
				return false;
			elseif ((rhs.f_online == nil) and lhs.f_online) then
				return true;
			end
			if(lhs.f_online == 1 and rhs.f_online ~= 1) then
				return true;
			elseif (rhs.f_online == 1 and lhs.f_online ~=1) then
				return false;
			end
			if(lhs.hour == nil) then
				lhs.hour = 0;
			end
			lhs.hours = lhs.hour;
			if(lhs.day) then
				lhs.hours = lhs.hours + (24*lhs.day);
			end
			if(lhs.month) then
				--Close enough :)
				lhs.hours = lhs.hours + (30*24*lhs.month);
			end 
			if(lhs.year) then
				--Might as well stick with the formula..
				lhs.hours = lhs.hours + (12*30*24*lhs.year);
			end
			if(rhs.hour == nil) then
				rhs.hour = 0;
			end
			rhs.hours = rhs.hour;
			if(rhs.day) then
				rhs.hours = rhs.hours + (24*rhs.day);
			end
			if(rhs.month) then
				--Close enough :)
				rhs.hours = rhs.hours + (30*24*rhs.month);
			end 
			if(rhs.year) then
				--Might as well stick with the formula..
				rhs.hours = rhs.hours + (12*30*24*rhs.year);
			end
			if(lhs.hours < rhs.hours) then
				return true;
			elseif (rhs.hours < lhs.hours) then
				return false;
			end
		elseif(go_SortType  == "Officer") then
		    if(lhs.f_officernote < rhs.f_officernote) then
				return true;
		    elseif (rhs.f_officernote < lhs.f_officernote) then
				return false;
		    end
	 	end
		--Secondary sort types
		if( not (go_SortType == "Name") ) then
	       if(lhs.f_name < rhs.f_name) then
		       return true;
	       elseif (rhs.f_name < lhs.f_name) then
		       return false;
	       end
		end
		if(not (go_SortType  == "Lvl")) then
			if(lhs.f_lvl < rhs.f_lvl) then
				return true;
			elseif (rhs.f_lvl < lhs.f_lvl) then
				return false;
			end
		end
	end

	if(go_ReverseSort > 0) then
        if(go_SortType == "Name") then
        	if(lhs.f_name > rhs.f_name) then
            	return true;
            elseif (rhs.f_name > lhs.f_name) then
                return false;
			end

		elseif(go_SortType == "Alts") then
        	if(lhs.f_alt > rhs.f_alt) then
            	return true;
			elseif (rhs.f_alt > lhs.f_alt) then
                return false;
			end
        elseif(go_SortType == "Lvl") then
            if(lhs.f_lvl > rhs.f_lvl) then
            	return true;
            elseif (rhs.f_lvl > lhs.f_lvl) then
                  return false;
            end
	    elseif(go_SortType  == "Class") then
            if(lhs.f_class > rhs.f_class) then
            	return true;
            elseif (rhs.f_class > lhs.f_class) then
                return false;
            end
        elseif(go_SortType  == "Zone") then
            if(lhs.f_zone > rhs.f_zone) then
            	return true;
            elseif (rhs.f_zone > lhs.f_zone) then
                return false;
            end
        elseif(go_SortType  == "Note") then
            if(lhs.f_note > rhs.f_note) then
            	return true;
            elseif (rhs.f_note > lhs.f_note) then
                return false;
            end
        elseif(go_SortType  == "PNote") then
            if(lhs.f_p_note > rhs.f_p_note) then
                return true;
            elseif (rhs.f_p_note > lhs.f_p_note) then
                return false;
            end
        elseif(go_SortType  == "Rank") then
            if(lhs.f_rankIndex < rhs.f_rankIndex) then
                return true;
            elseif (rhs.f_rankIndex < lhs.f_rankIndex) then
                return false;
            end
		elseif(go_SortType == "Last Online") then
			lhs.year, lhs.month, lhs.day, lhs.hour = GetGuildRosterLastOnline(lhs.f_id);	
			rhs.year, rhs.month, rhs.day, rhs.hour = GetGuildRosterLastOnline(rhs.f_id);
			----GuildOrg_Debug("LHS years: "..tostring(lhs.year).." months "..tostring(lhs.month).." days "..tostring(lhs.day).." hours "..tostring(lhs.hour).." online "..tostring(lhs.f_online));
			----GuildOrg_Debug("RHS years: "..tostring(rhs.year).." months "..tostring(rhs.month).." days "..tostring(rhs.day).." hours "..tostring(rhs.hour).." online "..tostring(rhs.f_online));
			if((lhs.f_online == nil) and rhs.f_online) then
				return true;
			elseif ((rhs.f_online == nil) and lhs.f_online) then
				return false;
			end
			if(lhs.f_online == 1 and rhs.f_online ~= 1) then
				return false;
			elseif (rhs.f_online == 1 and lhs.f_online ~=1) then
				return true;
			end
			if(lhs.hour == nil) then
				lhs.hour = 0;
			end
			lhs.hours = lhs.hour;
			if(lhs.day) then
				lhs.hours = lhs.hours + (24*lhs.day);
			end
			if(lhs.month) then
				--Close enough :)
				lhs.hours = lhs.hours + (30*24*lhs.month);
			end 
			if(lhs.year) then
				--Might as well stick with the formula..
				lhs.hours = lhs.hours + (12*30*24*lhs.year);
			end
			if(rhs.hour == nil) then
				rhs.hour = 0;
			end
			rhs.hours = rhs.hour;
			if(rhs.day) then
				rhs.hours = rhs.hours + (24*rhs.day);
			end
			if(rhs.month) then
				--Close enough :)
				rhs.hours = rhs.hours + (30*24*rhs.month);
			end 
			if(rhs.year) then
				--Might as well stick with the formula..
				rhs.hours = rhs.hours + (12*30*24*rhs.year);
			end
			if(lhs.hours > rhs.hours) then
				return true;
			elseif (rhs.hours > lhs.hours) then
				return false;
			end
    	elseif(go_SortType  == "Officer") then
            if(lhs.f_officernote > rhs.f_officernote) then
                return true;
            elseif (rhs.f_officernote > lhs.f_officernote) then
                  return false;
            end
        end
		--Secondary sort types
	    if( not (go_SortType == "Name") ) then
            if(lhs.f_name > rhs.f_name) then
                return true;
            elseif (rhs.f_name > lhs.f_name) then
                return false;
            end
        end
        if(not (go_SortType  == "Lvl")) then
            if(lhs.f_lvl > rhs.f_lvl) then
                return true;
            elseif (rhs.f_lvl > lhs.f_lvl) then
                return false;
            end
        end
	end
	return false;
end


function GuildOrg_SetSortType(go_type)
--------------------
-- Column buttons set this for sorting the guild list
--------------------
	
GuildOrg_Debug("Set Sort Type to "..go_type);
	if(go_type == "Note") then
        local c_text = GuildOrgFrameColumnHeader6:GetText();                
		if(c_text == "Rank") then
			if(go_SortType == "Rank") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
			go_SortType = "Rank";
		elseif(c_text == "Officer Note") then
			if(go_SortType == "Officer") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
	        go_SortType = "Officer";
		elseif(c_text == "Last Online") then
			if(go_SortType == "Last Online") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end
			go_SortType = "Last Online";
	    else
			if(go_SortType == "Note") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
            go_SortType = "Note";
        end
    end

	if(go_type == "PNote") then
        local c_text = GuildOrgFrameColumnHeader7:GetText();
        if(c_text == "Rank") then
			if(go_SortType == "Rank") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
            go_SortType = "Rank";
        elseif(c_text == "Officer Note") then
			if(go_SortType == "Officer") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
            go_SortType = "Officer";
		elseif(c_text == "Last Online") then
			if(go_SortType == "Last Online") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end
			go_SortType = "Last Online";
        else
			if(go_SortType == "PNote") then
				if(go_ReverseSort > 0) then
					go_ReverseSort = 0;
				else
					go_ReverseSort = 1;
				end
			end	
            go_SortType = "PNote";
        end
    end
	
	if (go_type == "PNote")then
		return;
	elseif (go_type == "Note") then
		return;
	end

	if(go_SortType == go_type) then
		if(go_ReverseSort > 0) then
			go_ReverseSort = 0;
		else
			go_ReverseSort = 1;
		end
	end
	go_SortType = go_type;
end


function SetGuildOrgShowOffline()
--------------------
-- Toggle showoffline members.
--------------------

GuildOrg_Debug("Show Offline Toggle");
	if( this:GetChecked()) then
		go_ShowOfflineMembers = 1;
		GuildOrg_Update();
	else
		go_ShowOfflineMembers = 0;
		GuildOrg_Update();
	end
end


function GuildOrg_UpdateCount()
--------------------
-- Updates global go_NumOnline, go_numGuildMembers, go_NumAlts, go_NumAltsTotal
--------------------

GuildOrg_Debug("Update Count");
	
    go_numGuildMembers = GetNumGuildMembers();
	GuildOrg_Debug("go_numGuildMembers = "..go_numGuildMembers);
	SetGuildRosterShowOffline(1);
	if(go_Window_Open == 1) then
		HideUIPanel(FriendsFrame);
	end
	go_NumOnline=0;
	go_NumAlts=0;
	go_NumAltsTotal=0;
	
	for i=1,go_numGuildMembers,1 do
		local go_name, go_rank, go_rankIndex, go_level, go_class, go_zone, go_note, go_officernote, go_online = GetGuildRosterInfo(i);
		--Add 1 to online if they are online. If the player is an alt then add 1 to alts online and total alts
		if(go_online==1)then
			go_NumOnline=go_NumOnline+1;
			if(GuildOrg_CheckForEntry(go_name)>0)then
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_name)].f_alt ~= (nil or " "))then
					go_NumAlts=go_NumAlts+1;
					go_NumAltsTotal=go_NumAltsTotal+1;
				end
			end
		--Add 1 to total alts if they are an alt and offline.
		else	
			if(GuildOrg_CheckForEntry(go_name)>0)then
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_name)].f_alt ~= (nil or " "))then
					go_NumAltsTotal=go_NumAltsTotal+1;
				end
			end
		end
	end
		
    GuildOrgFrameOnlineTotals:SetText("Total Guild Members: "..go_numGuildMembers.." - "..go_NumOnline.." online ("..go_NumAlts.." are alts).");
end


function GuildOrg_DrawMOTD()
--------------------
-- Draws the MOTD on two lines, grand total of around 210 characters instead of the normal 60
--------------------

GuildOrg_Debug("Draw MOTD");
	local guildMOTD = GetGuildRosterMOTD();
	if ( (not guildMOTD) or (guildMOTD == "") ) then
		guildMOTD = " ";
	end
	GuildOrgMOTD:SetText("Guild MOTD: "..string.sub(guildMOTD, 1, 105)); --First line
	GuildOrgMOTD2:SetText(string.sub(guildMOTD, 106, 210));              --Second line
end


function GuildOrg_Update()
--------------------
-- Updates the GuildOrg display
--------------------

GuildOrg_Debug("GuildOrg Update Initiated");
    
	if (go_Variables_Loaded == 0) then
        GuildOrg_Debug("Update Table, Variables Not Loaded");
	    return;
    end
	
	-- Player Options Enable/Disable
    if (CanEditMOTD())then
		GuildOrgMOTDButton:Enable()
	else
		GuildOrgMOTDButton:Disable()
	end
	if (CanEditOfficerNote())then
		GuildOrgOfficerNoteButton:Enable()
	else
		GuildOrgOfficerNoteButton:Disable()
	end
	if(CanEditPublicNote())then
		GuildOrgPublicNoteButton:Enable()
	else
		GuildOrgPublicNoteButton:Disable()
	end
	if(CanGuildDemote())then
		GuildOrgDemoteButton:Enable()
	else
		GuildOrgDemoteButton:Disable()
	end
	if(CanGuildInvite())then
		GuildOrgInviteButton:Enable()
	else
		GuildOrgInviteButton:Disable()
	end
	if(CanGuildPromote())then
		GuildOrgPromoteButton:Enable()
	else
		GuildOrgPromoteButton:Disable()
	end
	if(CanGuildRemove())then
		GuildOrgDeleteButton:Enable()
	else
		GuildOrgDeleteButton:Disable()
	end
	if(CanViewOfficerNote())then
		GuildOrgCPAuto_OfficerCheck:Enable()
	else
		GuildOrgCPAuto_OfficerCheck:Disable()
		GuildOrg_CP_set("auto_officer",0);
	end
	    
    local go_displayCharecters, go_displayCount, go_displayOff, go_altShown, go_guildIndex=0,0,0,0,0; 
    local i=1;
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	
	--Counts all alts that are being shown
	for h=1,size,1 do
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_expand == 1)then
			local count = 0;
			for g=1,size,1 do
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_name==go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[g].f_alt)then
					go_altShown=go_altShown+1;
					count = count+1;
				end
			end
			if(count == 0)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_expand = 0;
			end
		end
	end	

	--If someone's alt is on, then we want to show that player's alts and count them; also checks each main and sees if they indeed have an alt
	for h=1,size,1 do
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_isAlt == 1)then
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_online == 1)then
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_alt)].f_expand == 0)then
					go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_alt)].f_expand = 1;
					for g=1,size,1 do
						if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_alt==go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[g].f_alt)then
							go_altShown=go_altShown+1;
						end
					end
					--Removing one of them since it's already counted in the online total
					go_altShown=go_altShown-1;
				end
			end
		elseif(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_isAlt == 2)then
			local x = 0;
			for g=1,size,1 do
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_name==go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[g].f_alt)then
					x=x+1;
				end
			end
			if(x==0)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[h].f_isAlt = 0;
			end
		end
	end
	
	--If not showing all members then sort it normal, otherwise put all the alts at the bottom
	if(go_ShowOfflineMembers == 1)then
		local v,a = 1,0;
		while(v<go_numGuildMembers and a<go_NumAltsTotal)do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_isAlt == 1)then	
				local go_member = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v];
				----GuildOrg_Debug("v="..v.." a="..a.." player "..go_member.f_name);
				table.remove(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,v);
				table.insert(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,go_member);
				a=a+1;
			else
				v=v+1;
			end
		end
		v=1;
		GuildOrg_Debug("Checking for shown alts");
		while(v<go_numGuildMembers)do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_isAlt == 2)then
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_expand == 1)then
					GuildOrg_Debug("Is a main, checking "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_name);
					a,b=0,go_numGuildMembers;
					while(a<go_NumAltsTotal)do
						if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[b].f_alt == go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_name)then
							if(b~=v+1)then
								local go_member_alt = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[b];
								GuildOrg_Debug("Moving "..go_member_alt.f_name);
								table.remove(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,b);
								table.insert(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,v+1,go_member_alt);
								GuildOrg_Debug(v..": v-1="..tostring(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v-1].f_name).." v="..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v].f_name.." v+1="..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[v+1].f_name);
							else
								b=b-1;
							end
						else
							b=b-1;
						end
						a=a+1
					end
				end
			end
			v=v+1;
		end
	else
		if(go_RealmRef[go_Realm].go_GuildList) then
			local tmp_ref = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList;
			table.sort( go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList, GuildOrgPredicate);
		end
	end
	
	--Decide how many members to display in list
    if(go_ShowOfflineMembers == 1)then
        if((go_numGuildMembers-go_NumAltsTotal+go_altShown)<GO_GUILDMEMBERS_TO_DISPLAY)then
			go_displayCharecters=go_numGuildMembers-go_NumAltsTotal+go_altShown;
			go_displayOff=go_displayCharecters;
		else
			go_displayCharecters=GO_GUILDMEMBERS_TO_DISPLAY;
			go_displayOff=go_numGuildMembers-go_NumAltsTotal+go_altShown;
		end
		getglobal("GuildOrgExpandButtonAll"):Show();
    else
        if(go_NumOnline<GO_GUILDMEMBERS_TO_DISPLAY)then
			go_displayCharecters=go_NumOnline;
			go_displayOff=go_displayCharecters;
        else
			go_displayCharecters=GO_GUILDMEMBERS_TO_DISPLAY;
			go_displayOff=go_displayCharecters;
        end
		getglobal("GuildOrgExpandButtonAll"):Hide();
    end
	
	--ScrollFrame update
	local go_scrollShown = GuildOrg_ScrollFrame_Update(GuildOrgScrollFrame, go_displayOff, go_displayCharecters, GO_FRAME_HEIGHT );
	go_guildIndex = GuildOrg_ScrollFrame_GetOffset(GuildOrgScrollFrame);
	
	--Set the offset to 0 if we arent showing the scrollbar
	if(go_scrollShown == nil)then
		go_guildIndex = 0;
	end
	
	GuildOrg_Debug("Show Offline Members: "..go_ShowOfflineMembers..", number of members online: "..go_NumOnline..", display charecters: "..go_displayCharecters..", offset: "..go_guildIndex..", scroll bar shown: "..tostring(go_scrollShown));
	while(i<=go_displayCharecters)do
		go_guildIndex = go_guildIndex+1;
		if(go_guildIndex>go_numGuildMembers)then
			GuildOrg_Debug("Too far... oops?","magenta");
			getglobal("GuildOrgButton"..i.."Name"):SetText("");
			getglobal("GuildOrgButton"..i.."Alts"):SetText("");
            getglobal("GuildOrgButton"..i.."Zone"):SetText("");
            getglobal("GuildOrgButton"..i.."Lvl"):SetText("");
            getglobal("GuildOrgButton"..i.."Class"):SetText("");
            if(go_PublicToggle == "Rank") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    elseif(go_PublicToggle == "Officer") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    elseif(go_PublicToggle == "Last Online") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    else
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("")
		    end
		    if(go_PrivateToggle == "Rank") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    elseif(go_PrivateToggle == "Officer") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    elseif(go_PrivateToggle == "Last Online") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    else
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    end
            --Hide Unneeded Buttons
			getglobal("GuildOrgButton"..i):Hide();
            getglobal("GuildOrgCheckButton"..i):Hide();
			getglobal("GuildOrgExpandButton"..i):Hide();
			i=i+1;
		else
			local go_member = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_guildIndex];
			----GuildOrg_Debug("i="..i..", go_guildIndex="..go_guildIndex..", go_member.f_name="..go_member.f_name..", go_member.f_isAlt="..go_member.f_isAlt,"purple");
			if(go_member)then
				----GuildOrg_Debug("true","green");
				if(go_member.f_guild==go_guildName)then
					--Guild Member
					----GuildOrg_Debug("Guild Member","green");
					if(go_ShowOfflineMembers==0 and go_member.f_online==1)then
						--Show only online members
						----GuildOrg_Debug("onlne, show player "..go_member.f_name,"green");
						--Show this button
						getglobal("GuildOrgButton"..i):Show();
						--Insert player data
						getglobal("GuildOrgButton"..i.."Name"):SetText(go_member.f_name);
						if(go_member.f_alt ~= (nil or " "))then
							getglobal("GuildOrgButton"..i.."Alts"):SetText("("..go_member.f_alt..")");
						else
							getglobal("GuildOrgButton"..i.."Alts"):SetText("");
						end
    	   	 			getglobal("GuildOrgButton"..i.."Zone"):SetText(go_member.f_zone);
       		 			getglobal("GuildOrgButton"..i.."Lvl"):SetText(go_member.f_lvl);
       		 			getglobal("GuildOrgButton"..i.."Class"):SetText(go_member.f_class);
       		 			if(go_PublicToggle == "Rank") then
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_rank);
						elseif(go_PublicToggle == "Officer") then
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_officernote);
						elseif(go_PublicToggle == "Last Online") then
							if(go_member.f_online==1) then
								getglobal("GuildOrgButton"..i.."Note"):SetText("Online");
							else
								getglobal("GuildOrgButton"..i.."Note"):SetText(LastOnlineText(go_member.f_id));
							end
						else
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_note)
						end
						if(go_PrivateToggle == "Rank") then
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_rank);
						elseif(go_PrivateToggle == "Officer") then
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_officernote);
						elseif(go_PrivateToggle == "Last Online") then
							if(go_member.f_online==1) then
								getglobal("GuildOrgButton"..i.."PNote"):SetText("Online");
							else
								getglobal("GuildOrgButton"..i.."PNote"):SetText(LastOnlineText(go_member.f_id));
							end
						else
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_p_note);
						end
    	   	 			--Color Charecter Data
						if(go_member.f_alt ~= (nil or " "))then
							getglobal("GuildOrgButton"..i.."Name"):SetTextColor(0, 0.85, 1.0);
						else
							getglobal("GuildOrgButton"..i.."Name"):SetTextColor(1.0, 0.82, 0.0);
						end
						getglobal("GuildOrgButton"..i.."Alts"):SetTextColor(1.0, 1.0, 1.0);
						getglobal("GuildOrgButton"..i.."Zone"):SetTextColor(1.0, 1.0, 1.0);
						getglobal("GuildOrgButton"..i.."Lvl"):SetTextColor(1.0, 1.0, 1.0);
						getglobal("GuildOrgButton"..i.."Class"):SetTextColor(1.0, 1.0, 1.0);
        				getglobal("GuildOrgButton"..i.."Note"):SetTextColor(1.0, 1.0, 1.0);
        				getglobal("GuildOrgButton"..i.."PNote"):SetTextColor(1.0, 1.0, 1.0);
        				--Show Check Button
        				getglobal("GuildOrgCheckButton"..i):Show();
						if(go_member.f_checked==1)then
							getglobal("GuildOrgCheckButton"..i):SetChecked(true);
						else
							getglobal("GuildOrgCheckButton"..i):SetChecked(false);
						end
						getglobal("GuildOrgExpandButton"..i):SetChecked(false);
        				--Hide Expand Button cause we don't want to show it.
        				getglobal("GuildOrgExpandButton"..i):Hide();
						--Go to next button
						i=i+1;
					elseif(go_ShowOfflineMembers==1 and go_member.f_isAlt ~=1)then
						--Show all members
						----GuildOrg_Debug("offline, but show "..go_member.f_name,"green");
						--Show this button
						getglobal("GuildOrgButton"..i):Show();
						--Insert player data
						getglobal("GuildOrgButton"..i.."Name"):SetText(go_member.f_name);
						if(go_member.f_alt ~= (nil or " "))then
							getglobal("GuildOrgButton"..i.."Alts"):SetText("("..go_member.f_alt..")");
						else
							getglobal("GuildOrgButton"..i.."Alts"):SetText("");
						end
        				getglobal("GuildOrgButton"..i.."Zone"):SetText(go_member.f_zone);
        				getglobal("GuildOrgButton"..i.."Lvl"):SetText(go_member.f_lvl);
        				getglobal("GuildOrgButton"..i.."Class"):SetText(go_member.f_class);
        				if(go_PublicToggle == "Rank") then
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_rank);
						elseif(go_PublicToggle == "Officer") then
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_officernote);
						elseif(go_PublicToggle == "Last Online") then
							if(go_member.f_online==1) then
								getglobal("GuildOrgButton"..i.."Note"):SetText("Online");
							else
								getglobal("GuildOrgButton"..i.."Note"):SetText(LastOnlineText(go_member.f_id));
							end
						else
							getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_note)
						end
						if(go_PrivateToggle == "Rank") then
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_rank);
						elseif(go_PrivateToggle == "Officer") then
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_officernote);
						elseif(go_PrivateToggle == "Last Online") then
							if(go_member.f_online==1) then
								getglobal("GuildOrgButton"..i.."PNote"):SetText("Online");
							else
								getglobal("GuildOrgButton"..i.."PNote"):SetText(LastOnlineText(go_member.f_id));
							end
						else
							getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_p_note);
						end
        				--Color Charecter Data
        				if (go_member.f_online==1) then
							getglobal("GuildOrgButton"..i.."Name"):SetTextColor(1.0, 0.82, 0.0);
							getglobal("GuildOrgButton"..i.."Alts"):SetTextColor(1.0, 1.0, 1.0);
							getglobal("GuildOrgButton"..i.."Zone"):SetTextColor(1.0, 1.0, 1.0);
							getglobal("GuildOrgButton"..i.."Lvl"):SetTextColor(1.0, 1.0, 1.0);
							getglobal("GuildOrgButton"..i.."Class"):SetTextColor(1.0, 1.0, 1.0);
        				    getglobal("GuildOrgButton"..i.."Note"):SetTextColor(1.0, 1.0, 1.0);
        				    getglobal("GuildOrgButton"..i.."PNote"):SetTextColor(1.0, 1.0, 1.0);
						else
							getglobal("GuildOrgButton"..i.."Name"):SetTextColor(0.5, 0.5, 0.5);
							getglobal("GuildOrgButton"..i.."Alts"):SetTextColor(0.5, 0.5, 0.5);
							getglobal("GuildOrgButton"..i.."Zone"):SetTextColor(0.5, 0.5, 0.5);
							getglobal("GuildOrgButton"..i.."Lvl"):SetTextColor(0.5, 0.5, 0.5);
							getglobal("GuildOrgButton"..i.."Class"):SetTextColor(0.5, 0.5, 0.5);
        				    getglobal("GuildOrgButton"..i.."Note"):SetTextColor(0.5, 0.5, 0.5);
        				    getglobal("GuildOrgButton"..i.."PNote"):SetTextColor(0.5, 0.5, 0.5);
						end
       	 			--Show Check Button
						getglobal("GuildOrgCheckButton"..i):Show();
						if(go_member.f_checked==1)then
							getglobal("GuildOrgCheckButton"..i):SetChecked(true);
						else
							getglobal("GuildOrgCheckButton"..i):SetChecked(false);
						end
						if(go_member.f_expand==1)then
							getglobal("GuildOrgExpandButton"..i):SetChecked(true);
						else
							getglobal("GuildOrgExpandButton"..i):SetChecked(false);
						end
       	 			--Hide or Show Expand Button
        				if(go_member.f_isAlt == 0)then
							getglobal("GuildOrgExpandButton"..i):Hide();
						else
							getglobal("GuildOrgExpandButton"..i):Show();
						end
						--if(getglobal("GuildOrgExpandButton"..i):GetChecked())then
						--	i=GuildOrg_DisplayAlts(go_member.f_name,i,go_displayCharecters);
						--end
						--Go to next button
						i=i+1;
					elseif(go_ShowOfflineMembers==1 and go_member.f_isAlt==1)then
						--Alt, check to see if main is expanded or not.
						if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_member.f_alt)].f_expand == 1)then
							--True, then show
							----GuildOrg_Debug("alt, but show player "..go_member.f_name,"green");
							--Show this button
							getglobal("GuildOrgButton"..i):Show();
							--Insert player data
							getglobal("GuildOrgButton"..i.."Name"):SetText("  "..go_member.f_name);
							getglobal("GuildOrgButton"..i.."Alts"):SetText("("..go_member.f_alt..")");
        					getglobal("GuildOrgButton"..i.."Zone"):SetText(go_member.f_zone);
        					getglobal("GuildOrgButton"..i.."Lvl"):SetText(go_member.f_lvl);
        					getglobal("GuildOrgButton"..i.."Class"):SetText(go_member.f_class);
        					if(go_PublicToggle == "Rank") then
								getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_rank);
							elseif(go_PublicToggle == "Officer") then
								getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_officernote);
							elseif(go_PublicToggle == "Last Online") then
								if(go_member.f_online==1) then
									getglobal("GuildOrgButton"..i.."Note"):SetText("Online");
								else
									getglobal("GuildOrgButton"..i.."Note"):SetText(LastOnlineText(go_member.f_id));
								end
							else
								getglobal("GuildOrgButton"..i.."Note"):SetText(go_member.f_note)
							end
							if(go_PrivateToggle == "Rank") then
								getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_rank);
							elseif(go_PrivateToggle == "Officer") then
								getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_officernote);
							elseif(go_PrivateToggle == "Last Online") then
								if(go_member.f_online==1) then
									getglobal("GuildOrgButton"..i.."PNote"):SetText("Online");
								else
									getglobal("GuildOrgButton"..i.."PNote"):SetText(LastOnlineText(go_member.f_id));
								end
							else
								getglobal("GuildOrgButton"..i.."PNote"):SetText(go_member.f_p_note);
							end
        					--Color Charecter Data
        					if (go_member.f_online==1) then
								getglobal("GuildOrgButton"..i.."Name"):SetTextColor(0, 0.85, 1.0);
								getglobal("GuildOrgButton"..i.."Alts"):SetTextColor(1.0, 1.0, 1.0);
								getglobal("GuildOrgButton"..i.."Zone"):SetTextColor(1.0, 1.0, 1.0);
								getglobal("GuildOrgButton"..i.."Lvl"):SetTextColor(1.0, 1.0, 1.0);
								getglobal("GuildOrgButton"..i.."Class"):SetTextColor(1.0, 1.0, 1.0);
        					    getglobal("GuildOrgButton"..i.."Note"):SetTextColor(1.0, 1.0, 1.0);
        					    getglobal("GuildOrgButton"..i.."PNote"):SetTextColor(1.0, 1.0, 1.0);
							else
								getglobal("GuildOrgButton"..i.."Name"):SetTextColor(0.5, 0.5, 0.5);
								getglobal("GuildOrgButton"..i.."Alts"):SetTextColor(0.5, 0.5, 0.5);
								getglobal("GuildOrgButton"..i.."Zone"):SetTextColor(0.5, 0.5, 0.5);
								getglobal("GuildOrgButton"..i.."Lvl"):SetTextColor(0.5, 0.5, 0.5);
								getglobal("GuildOrgButton"..i.."Class"):SetTextColor(0.5, 0.5, 0.5);
        					    getglobal("GuildOrgButton"..i.."Note"):SetTextColor(0.5, 0.5, 0.5);
        					    getglobal("GuildOrgButton"..i.."PNote"):SetTextColor(0.5, 0.5, 0.5);
							end
       	 					--Show Check Button
							getglobal("GuildOrgCheckButton"..i):Show();
							if(go_member.f_checked==1)then
								getglobal("GuildOrgCheckButton"..i):SetChecked(true);
							else
								getglobal("GuildOrgCheckButton"..i):SetChecked(false);
							end
							getglobal("GuildOrgExpandButton"..i):SetChecked(false);
							getglobal("GuildOrgExpandButton"..i):Hide();
							i=i+1;
						end
					else
						--Don't want to show player because they are offline or hidden
						----GuildOrg_Debug("offline or hidden","red");
					end
				else
					--Don't want to show player because they are not in the guild
					----GuildOrg_Debug("not in guild","red");
				end
			else
				--Don't know what the hell it is, skip it
				----GuildOrg_Debug("false","red");
			end
		end
	end
					
	--Clearing text of blank buttons
    if(go_displayCharecters<GO_GUILDMEMBERS_TO_DISPLAY)then
        local go_temp = go_displayCharecters+1;
		for i=go_temp, GO_GUILDMEMBERS_TO_DISPLAY, 1 do
            --Clear Text
            getglobal("GuildOrgButton"..i.."Name"):SetText("");
			getglobal("GuildOrgButton"..i.."Alts"):SetText("");
            getglobal("GuildOrgButton"..i.."Zone"):SetText("");
            getglobal("GuildOrgButton"..i.."Lvl"):SetText("");
            getglobal("GuildOrgButton"..i.."Class"):SetText("");
            if(go_PublicToggle == "Rank") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    elseif(go_PublicToggle == "Officer") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    elseif(go_PublicToggle == "Last Online") then
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("");
		    else
		    	getglobal("GuildOrgButton"..i.."Note"):SetText("")
		    end
		    if(go_PrivateToggle == "Rank") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    elseif(go_PrivateToggle == "Officer") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    elseif(go_PrivateToggle == "Last Online") then
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    else
		    	getglobal("GuildOrgButton"..i.."PNote"):SetText("");
		    end
            --Hide Unneeded Buttons
			getglobal("GuildOrgButton"..i):Hide();
            getglobal("GuildOrgCheckButton"..i):Hide();
			getglobal("GuildOrgExpandButton"..i):Hide();
        end
    end
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------   GuildOrg BUTTON FUNCTIONS SECTION   ---------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

--	GuildOrg_PublicToggle_OnClick()		--Cycles the second to last column through the optional lists. (Rank, Officer Note, Public note)
--	GuildOrg_PrivateToggle_OnClick()	--Cycles the last column through the optional list. (Rank, Officer Note, Private Note)
--  GuildOrg_CheckButton_OnClick()      --Called when a check button other than the show offline is clicked.
--	GuildOrg_ExpandButton_OnClick()		--Called when an expand button is clicked.
--	GuildOrg_SetMOTD_OnClick()			--Called when the Guild Org set motd button is clicked.
--	GuildOrg_Button_OnClick()			--Called when a guild member on the guildorg list is clicked.
--	GuildOrg_AddPrivate_OnClick()		--Called when the private note button is clicked.
--	GuildOrg_AddPublic_OnClick()		--Called when the public note button is clicked.
--	GuildOrg_AddOfficer_OnClick()		--Called when the officer note button is clicked.
--	GuildOrg_Promote_OnClick()			--Called when the Promote button is clicked.
--	GuildOrg_Demote_OnClick()			--Called when the demote button is clicked.
--	GuildOrg_Invite_OnClick()			--Called when the invite button is clicked.
--	GuildOrg_Delete_OnClick()			--Called when the delete button is clicked.
--  GuildOrg_Delete_Player()			--Removes players who are checked.
--	GuildOrg_Main_OnClick()				--Called when the Set Main button is clicked.
--	GuildOrg_AutoCombine()				--Called when the Auto Combine button is pressed.

function GuildOrg_PublicToggle_OnClick()
--------------------
-- Column toggles on click (Second to last column)
--------------------

GuildOrg_Debug("Public Toggle clicked");
	if(go_PublicToggle == "Rank") then
		if(CanViewOfficerNote())then
			go_PublicToggle = "Officer";
			GuildOrgFrameColumnHeader6:SetText("Officer Note");
		else
			go_PublicToggle = "Note";		
			GuildOrgFrameColumnHeader6:SetText("Public Note");
		end
	elseif(go_PublicToggle == "Officer") then
		go_PublicToggle = "Note";		
		GuildOrgFrameColumnHeader6:SetText("Public Note");
	elseif(go_PublicToggle == "Note") then
		go_PublicToggle = "Last Online";
		GuildOrgFrameColumnHeader6:SetText("Last Online");
	else
		go_PublicToggle = "Rank";
		GuildOrgFrameColumnHeader6:SetText("Rank");
	end
	GuildOrg_Update();
end


function GuildOrg_PrivateToggle_OnClick()
--------------------
-- Column toggles on click (last column)
--------------------

GuildOrg_Debug("Private Toggle clicked");
	if(go_PrivateToggle == "Rank") then
		if(CanViewOfficerNote())then
			go_PrivateToggle = "Officer";
			GuildOrgFrameColumnHeader7:SetText("Officer Note");
		else
			go_PrivateToggle = "PNote";		
			GuildOrgFrameColumnHeader7:SetText("Private Note");
		end
	elseif(go_PrivateToggle == "Officer") then
		go_PrivateToggle = "PNote";		
		GuildOrgFrameColumnHeader7:SetText("Private Note");
	elseif(go_PrivateToggle == "PNote") then
		go_PrivateToggle = "Last Online";
		GuildOrgFrameColumnHeader7:SetText("Last Online");
	else
		go_PrivateToggle = "Rank";
		GuildOrgFrameColumnHeader7:SetText("Rank");
	end
	GuildOrg_Update();
end


function GuildOrg_CheckButton_OnClick()
--------------------
-- Called when a checkbox (other than show offline) is clicked.
--------------------
    
    local id = this:GetID();
	GuildOrg_Debug("Check "..id.." clicked");
	
	--If the button is the all button, then check/uncheck all
	if(id==117)then
		if(not getglobal("GuildOrgCheckButtonAll"):GetChecked())then
			GuildOrg_Debug("Checked true, unchecking all");
			for i=1,go_numGuildMembers,1 do
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked = 0;
			end
			
			for i=1,GO_GUILDMEMBERS_TO_DISPLAY,1 do
				getglobal("GuildOrgCheckButton"..i):SetChecked(false);
			end
			getglobal("GuildOrgCheckButtonAll"):SetChecked(false);
		else
			GuildOrg_Debug("Checked false, checking all");
			for i=1,go_numGuildMembers,1 do
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked = 1;
			end
			
			for i=1,GO_GUILDMEMBERS_TO_DISPLAY,1 do
				getglobal("GuildOrgCheckButton"..i):SetChecked(true);
			end
			getglobal("GuildOrgCheckButtonAll"):SetChecked(true);
		end
		GuildOrg_Update();
		return;
	end
	
	local go_name = getglobal("GuildOrgButton"..id.."Name"):GetText();
	go_name = gsub(go_name, "%s*([^%s]+).*", "%1");
	local tmp_row = GuildOrg_CheckForEntry(go_name);
	
	if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked == (0 or nil)) then
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked = 1;
	else
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked = 0;
	end
end


function GuildOrg_ExpandButton_OnClick()
--------------------
-- Called when an expand button is clicked
--------------------
    
    local id = this:GetID();
	GuildOrg_Debug("Expand "..id.." clicked");
	
	--If the button is the all button, then expand/unexpand all
	if(id==117)then
		if(not getglobal("GuildOrgExpandButtonAll"):GetChecked())then
			GuildOrg_Debug("Expand true, unexpanding all");
			for i=1,go_numGuildMembers,1 do
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_expand = 0;
			end
			
			for i=1,GO_GUILDMEMBERS_TO_DISPLAY,1 do
				getglobal("GuildOrgExpandButton"..i):SetChecked(false);
			end
			getglobal("GuildOrgExpandButtonAll"):SetChecked(false);			
		else
			GuildOrg_Debug("Expand false, expanding all");
			for i=1,go_numGuildMembers,1 do
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_expand = 1;
			end
			
			for i=1,GO_GUILDMEMBERS_TO_DISPLAY,1 do
				getglobal("GuildOrgExpandButton"..i):SetChecked(true);
			end
			getglobal("GuildOrgExpandButtonAll"):SetChecked(true);
		end
		GuildOrg_Update();
		return;
	end
	
	local go_name = getglobal("GuildOrgButton"..id.."Name"):GetText();
	go_name = gsub(go_name, "%s*([^%s]+).*", "%1");
	local tmp_row = GuildOrg_CheckForEntry(go_name);
	
	if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_expand == (0 or nil)) then
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_expand = 1;
	else
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_expand = 0;
	end
	GuildOrg_Update();
end


function GuildOrg_SetMOTD_OnClick()
--------------------
-- Called when the Set Guild MOTD button is clicked
--------------------

GuildOrg_Debug("Set MOTD clicked");
	local text = GuildOrgEditBox:GetText();
	if (text ~= "") then
		GuildSetMOTD(text);
		GuildOrg_DrawMOTD();
	end
	--
	-- Reset edit box.
	--
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
end


function GuildOrg_Button_OnClick()
--------------------
-- Called when a guild member on the guild list is clicked
--------------------

    local id = this:GetID();
	GuildOrg_Debug("Guild Member "..id.." clicked");
	local go_name = getglobal("GuildOrgButton"..id.."Name"):GetText();
	go_name = gsub(go_name, "%s*([^%s]+).*", "%1");
	local tmp_row = GuildOrg_CheckForEntry(go_name);
	
	if(IsShiftKeyDown() and GuildOrgCP_CheckStates.shift_click == 1) then
	    --Whisper player, open chat box if not open.
		if ( not ChatFrameEditBox:IsVisible() ) then
       	    ChatFrame_OpenChat("/w "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name.." ");
       	else
       	    ChatFrameEditBox:SetText("/w "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name.." ");
       	end
       	ChatEdit_ParseText(ChatFrame1.editBox, 0);
		ChatFrameEditBox:SetFocus();
	return;
	end
	
	if(IsAltKeyDown() and GuildOrgCP_CheckStates.alt_click == 1 ) then
		--Convert to raid group is already at 5.
		if(GetNumPartyMembers() == 4 and UnitInRaid("player") == nil) then
			GuildOrg_Print("Auto-Convert to Raid activated! PLEASE Re-invite ".. go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name);
			ConvertToRaid();
			return;
		end
		--If not online, then don't invite.
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_online~=1)then
			GuildOrg_Print("Can not invite "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name..", player is offline.");
			return
		end
		GuildOrg_Print("Inviting "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name);
		InviteUnit(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name);
		return;
	end
	
	if(IsControlKeyDown() and GuildOrgCP_CheckStates.ctrl_click == 1 ) then
		local go_text = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_name;
		--Insert player name into edit box
		if(not ChatFrameEditBox:IsVisible())then
			GuildOrg_Debug(go_text);
			local go_temp = GuildOrgEditBox:GetText();
			GuildOrgEditBox:SetText(go_temp..go_text);
			return;
		--Insert player name into chat box
		else
			GuildOrg_Debug(text);
			local go_temp = ChatFrameEditBox:GetText();
			ChatFrameEditBox:SetText(go_temp..go_text);
			return;
		end
	end
	local go_member = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row]
	GuildOrg_Debug("Name: "..go_member.f_name.." Row: "..tmp_row);
	
	if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked == 0) then
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked = 1;
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_expand = 1;
		getglobal("GuildOrgCheckButton"..id):SetChecked(true);
	else
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_checked = 0;
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[tmp_row].f_expand = 0;
		getglobal("GuildOrgCheckButton"..id):SetChecked(false);
	end
	
	GuildOrg_Update();
end


function GuildOrg_AddPrivate_OnClick()
--------------------
-- Called when the Add Private Note button is clicked
--------------------

	local text = GuildOrgEditBox:GetText();
	GuildOrg_Debug("Add Private Note clicked, text is "..tostring(text));
	--Sets the text of the private note. If there is no text to set, then it clears it.
	if (text ~= "") then
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_p_note = text;			
			end
		end
	else
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_p_note = " ";			
			end
		end
	end
	
	GuildOrg_ClearChecks();
	GuildOrg_Update();
	--
	-- Reset edit box.
	--
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
end


function GuildOrg_AddPublic_OnClick()
--------------------
-- Called when the Set Public Note button is clicked
--------------------

	local text = GuildOrgEditBox:GetText();
	GuildOrg_Debug("Add Public Note clicked, text is "..tostring(text));
	--Sets the text of the public note. If there is no text to set, then it clears it.
	if (text ~= "") then
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				GuildRosterSetPublicNote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_id, text);			
			end
		end
	else
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				GuildRosterSetPublicNote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_id, " ");			
			end
		end
	end
	
	GuildOrg_ClearChecks();
	GuildOrg_Update();
	--
	-- Reset edit box.
	--
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
end


function GuildOrg_AddOfficer_OnClick()
--------------------
-- Called when the Set Officer Note button is clicked
--------------------

	local text = GuildOrgEditBox:GetText();
	GuildOrg_Debug("Add Officer Note clicked, text is "..tostring(text));
	--Sets the text of the officer note. If there is no text to set, then it clears it.	
	if (text ~= "") then
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				GuildRosterSetOfficerNote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_id, text);			
			end
		end
	else
		local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				GuildRosterSetOfficerNote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_id, " ");			
			end
		end
	end
	
	GuildOrg_ClearChecks();
	GuildOrg_Update();
	--
	-- Reset edit box.
	--
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
end


function GuildOrg_Promote_OnClick()
--------------------
-- Called when the Promote Member button is clicked
--------------------

	GuildOrg_Debug("Promote clicked");
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	for i=1, size,1 do
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
			GuildPromote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name);
		end
	end
	GuildOrg_ClearChecks();
end


function GuildOrg_Demote_OnClick()
--------------------
-- Called when the Demote Member button is clicked
--------------------
	GuildOrg_Debug("Demote clicked");
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	for i=1, size,1 do
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
			GuildDemote(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name);
		end
	end
	GuildOrg_ClearChecks();
end


function GuildOrg_Invite_OnClick()
--------------------
-- Called when the Guild Invite button is clicked
--------------------
	
	GuildOrg_Debug("Invite clicked");
	local text = GuildOrgEditBox:GetText();
	--Attempts to invite the player in the edit box. If no text is in the box, then invite target player.
	if(string.len(text)>0)then
		GuildOrg_Print("Attempting to invite "..text,1,1,0);
		GuildInvite(text);
	else
		GuildOrg_Print("Attempting to invite target player...",1,1,0);
		GuildInvite();
	end
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
end


function GuildOrg_Delete_OnClick()
--------------------
-- Executed when the Delete Character button is clicked
--------------------
	
	GuildOrg_Debug("Delete clicked");
	StaticPopup_Show ("GUILDORG_CONFIRM_DELETE");
end


function GuildOrg_Delete_Player()
--------------------
-- Removes checked players
--------------------	
	
	GuildOrg_Debug("Deleting Players");
	local i=1;
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	--goes through the table and removes each person who is checked
	while(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i]~=nil)do
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
			local d_name = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name;
			table.remove(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList, i);
			GuildUninvite(d_name);
		else
			i=i+1;
		end
	end
	GuildOrg_ClearChecks();
end


function GuildOrg_Main_OnClick()
--------------------
-- Called when the Set/Unset Main button is clicked
--------------------

	GuildOrg_Debug("Set Main clicked");
	local text = GuildOrgEditBox:GetText();
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	--Clear the main for this character
	if(text==(nil or ""))then
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt = " ";
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 0;
			end
		end
	--Set the main
	else
		for i=1, size,1 do
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked == 1) then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt = text;
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 1;
			end
		end
	end
	GuildOrgEditBox:ClearFocus();
	GuildOrgEditBox:SetText("");
	GuildOrg_ClearChecks();
	GuildOrg_UpdateMemberTable();
	GuildOrg_Update();
end


function GuildOrg_AutoCombine()
--------------------
--This function will iterate through the entire GO table. 
--For each entry it will attempt to find a "main" to associate 
--with based upon the officer notes, then the public notes if that fails.
--------------------

	GuildOrg_Print("Attempting to AutoCombine based on Officer Notes/Public Notes.");
	GuildOrg_Debug("Auto combine clicked");
	
	GuildOrg_UpdateMemberTable();
	
	for i=1,go_numGuildMembers,1 do
		GuildOrg_Debug(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name.." is being tested.","yellow");
		local go_noteCheck = GuildOrg_NoteCheck(i);
		if(go_noteCheck==1)then
			GuildOrg_Debug("Charecter had an alt specified; "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt,"green");
		else
			GuildOrg_Debug("Charecter has no alt specified, it fails.","red");
		end
	end
	GuildOrg_UpdateMemberTable();
	GuildOrg_Update();
end


--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
----------------------  GuildOrg TABLE FUNCTIONS SECTION  ----------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

--SESSION Tablename: go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList
----TABLES COLUMNS---------------------------------------------------------
-- f_rank			--Numeric rank assigned according to the Guild Rank.
-- f_rankIndex		--Data fromthe guild list. unused currently.
-- f_lvl			--Level of the character. 1 - 70
-- f_class			--Character class (ex. Rogue)
-- f_zone			--Zone character is currently in.. (warning this is nil sometimes when the char has just logged in).
-- f_note			--Public note.
-- f_guild			--Charecer's guild.
-- f_officernote	--Officer Note.
-- f_online			--1 if character is online, 0 if not.
-- f_expand			--1 if the user has clicked the + button next to this row in their GO window. 0 if not.
-- f_id				--Unique ID assigned to a row in the GO table.
-- f_alt			--This text string will show up in paranthesis next to the character's name if it is an alt and if the value is not " ".


--	GuildOrg_UpdateMemberTable()		--Adds unknown in guild characters to the GO Tables, updates existing members.
--	GuildOrg_CheckForEntry(go_Entry)	--Finds the first row in the table that has f_name == go_Entry and returns the row number. Returns 0 for not found.
--	GuildOrg_NewList()					--Creates the guild table when go_RealmRef[go_Realm] is detected as nil.
--  GuildOrg_DeleteGuildData()			--Clears the current player's guild data.
--	GuildOrg_ClearChecks()				--Clears the checked boxes and checked players.

function GuildOrg_UpdateMemberTable()
--------------------
-- Updates the go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList table. Checks the guild roster and adds any non existing entries.
--------------------

    --If the saved data hasn't been loaded, don't screw up anything.    
    if (go_Variables_Loaded == 0) then
        GuildOrg_Debug("Update Table, Variables Not Loaded");
	    return;
    end
    GuildOrg_Debug("Update Table, Variables Loaded");
    
	GuildOrg_UpdateCount();
	
	--If there are "no members "in your guild for whatever reason, then don't update the table
	if (go_numGuildMembers==0) then
		GuildOrg_Debug("No guild members in your guild, wtf?","red");
		return;
	end
	
    local go_name, go_rank, go_rankIndex, go_level, go_class, go_zone, go_note, go_pnote, go_officernote, go_online;
    local go_guildIndex, go_row;
    
	if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList == nil)then
		GuildOrg_Debug("List is nil, cursed you are my young friend.");
		return;
	end
	
    --Add/Update Members
    for i=1, go_numGuildMembers, 1 do
        go_guildIndex = i;
        go_name, go_rank, go_rankIndex, go_level, go_class, go_zone, go_note, go_officernote, go_online = GetGuildRosterInfo(go_guildIndex);
        go_row = GuildOrg_CheckForEntry(go_name);
        
		----GuildOrg_Debug("Name: "..go_name..", Row: "..go_row,"purple");
        --Update Current Entry
        if(go_row>0)then
			----GuildOrg_Debug("Updating","green");
			go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name = go_name;
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rank==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rank = "Unknown";
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rank = go_rank;
			end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rankIndex==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rankIndex = 0;
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_rankIndex = go_rankIndex;
			end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_lvl==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_lvl = 0;
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_lvl = go_level;
			end
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_class==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_class = "Unknown";
			else
            	go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_class = go_class;
			end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_zone==nil)then
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_zone = " ";
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_zone = go_zone;
            end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_note==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_note = " ";
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_note = go_note;
			end
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_guild==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_guild = "-1";
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_guild = go_guildName;
			end
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_officernote==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_officernote = " ";
			else
            	go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_officernote = go_officernote;
			end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_online==nil)then
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_online = LastOnlineText(go_guildIndex);
            else
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_online = go_online;
            end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_id == nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_id = -1;
			else
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_id = go_guildIndex;
			end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_checked==nil)then
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_checked = 0;
            end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_expand==nil)then
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_expand = 0;
            end
            if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_alt==nil)then
                go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_alt = " ";
            end
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_p_note==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_p_note = " ";
			end
        	if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_isAlt==nil)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_isAlt = 0;
			end
		
        --New Entry
        else
            --Check the fake guild list to see if they are in there
			go_row = GuildOrg_CheckForEntry(go_Entry,"-1")
			local p_note = " ";
			local p_alt = " ";
			if(go_row>0)then
				p_note = go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList[go_row].f_p_note;
				p_alt = go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList[go_row].f_alt;
			end
			if(go_online==nil)then
                go_online=LastOnlineText(go_guildIndex);
            end
            if(go_zone==nil)then
                go_zone=" ";
            end
            ----GuildOrg_Debug("Adding new member","blue");
            local go_new_entry = {
                f_name = go_name,
                f_rank = go_rank,
                f_rankIndex = go_rankIndex,
                f_lvl = go_level,
                f_class = go_class,
                f_zone = go_zone,
                f_note = go_note,
				f_guild = go_guildName,
                f_officernote = go_officernote,
                f_online = go_online,
                f_p_note = p_note,
                f_id = go_guildIndex,
                f_checked = 0,
                f_expand = 0,
                f_alt = " ",
				f_isAlt = 0};
            table.insert(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,go_new_entry);
        end
    end

	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList);
	GuildOrg_Debug("Checking for non-members","cyan");
	local i=1;
	--goes through the guild list and checks each player and looks for invalid data
	while(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i]~=nil)do
		local t_name = "";
		--if the player's name is nil, then set the name to x
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name==nil)then
			t_name = "x";
		else
			t_name = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name;
		end
		local in_guild = false;
		local t=1;
		--looks through the WoW guild list and makes sure the player is in the guild
		while(t<=go_numGuildMembers)do
			local g_name = GetGuildRosterInfo(t);
			if(t_name==g_name)then
				in_guild=true;
			end
			t=t+1;
		end
		
		--checks to see if the player is in the guild, if they are not then move them to "-1"
		if(in_guild==false)then
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_guild == go_guildName)then
				GuildOrg_Debug("Non-existant member "..t_name..", setting to \"guild\" -1.","red");
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_guild = "-1";
				table.insert(go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList,go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i]);
				table.remove(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,i);
			end
		else
			--Check for invalid main
			if(GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)==0 and go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt ~=(nil or " "))then
				GuildOrg_Print("Invalid main detected on "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name..", removing main name.");
				GuildOrg_Debug(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt.." is invalid",1,0,0);
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt = " ";
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 0;
			else
				if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt ~=(nil or " ") and go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)].f_isAlt == 1 and go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)].f_alt ~=(nil or " "))then
					GuildOrg_Print("Invalid main detected on "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_name..", removing main name. Reason is alt of an alt.");
					go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt = " ";
					go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 0;
				end
			end
			--If the charecter is an alt and f_isAlt is not 1, then set it; if the charecter has no main and f_isAlt is 1, then set it to 0
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt ~= (nil or " ") and go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt ~=1)then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 1;
			elseif(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt == 1 and go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt == (nil or " "))then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_isAlt = 0;
			end
			
			--Set the alt main's f_isAlt to 2
			if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt ~= (nil or " "))then
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)].f_isAlt = 2;
				----GuildOrg_Debug(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)].f_name.." is a main, f_isAlt = "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[GuildOrg_CheckForEntry(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_alt)].f_isAlt,"black");
			end
			i=i+1;
			--GuildOrg_Debug("Member "..t_name.." is either in "..go_guildName.." or in a different charecter's guild.","yellow");
		end
	end
	
	--removes anyone in the "-1" list with the invalid name of x
	while(go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList[i]~=nil)do
		local t_name = go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList[i].f_name;
		if(t_name=="x")then
			table.remove(go_RealmRef[go_Realm].go_GuildList["-1"].go_MemberList,i);
		else
			i=i+1;
		end
	end
	
	--on start, clear all checks for the current guild
	if(go_RunAtStart==0)then
		GuildOrg_ClearChecks();
		go_RunAtStart=1;
	end
	
end


function GuildOrg_CheckForEntry(go_Entry,go_Guild)
--------------------
-- Checks guild table to find out if an entry for a person already exists. Returns the row of the entry.
--------------------
	
	if(go_Guild == nil)then
		go_Guild=go_guildName;
	end
	local size = table.getn(go_RealmRef[go_Realm].go_GuildList[go_Guild].go_MemberList);
    for i=1, size, 1 do
        if ( go_RealmRef[go_Realm].go_GuildList[go_Guild].go_MemberList[i].f_name == go_Entry) then
			return i;
		end
    end
	return 0;
end


function GuildOrg_NewList()
--------------------
-- Creates the guild list on first use.
--------------------
	
	GuildOrg_Debug("New List!");
	GuildOrg_UpdateCount();
	for i=1, go_numGuildMembers, 1 do
		go_guildIndex = i;
		local go_name, go_rank, go_rankIndex, go_level, go_class, go_zone, go_note, go_officernote, go_online = GetGuildRosterInfo(i);
		if(go_online==nil)then
            go_online=LastOnlineText(i);
        end
        if(go_zone==nil)then
            go_zone=" ";
        end
        GuildOrg_Debug("Adding new member "..go_name..".","blue");
        local go_new_entry = {
            f_name = go_name,
            f_rank = go_rank,
            f_rankIndex = go_rankIndex,
            f_lvl = go_level,
            f_class = go_class,
            f_zone = go_zone,
            f_note = go_note,
			f_guild = go_guildName,
            f_officernote = go_officernote,
            f_online = go_online,
            f_p_note = " ",
            f_id = go_guildIndex,
            f_checked = 0,
            f_expand = 0,
            f_alt = " ",
			f_isAlt = 0};
        table.insert(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList,go_new_entry);
	end
	GuildOrg_Print("Finished creating new list!",0,1,0);
	GuildOrg_Debug("List size is: "..table.getn(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList),"yellow");
end


function GuildOrg_DeleteGuildData(go_Real,go_Guild)
--------------------
-- Clears current player's guild data.
--------------------

	if(go_Guild == nil)then
		go_Guild=go_guildName;
	end
	if(go_Realm == nil)then
		go_Real=go_Realm;
	end
	GuildOrg_Debug("Delete Guild Data","red");
	local i=1;
		
	while(go_RealmRef[go_Real].go_GuildList[go_Guild].go_MemberList[i]~=nil)do
		GuildOrg_Debug("Delete "..i.." "..go_RealmRef[go_Real].go_GuildList[go_Guild].go_MemberList[i].f_name);
		table.remove(go_RealmRef[go_Real].go_GuildList[go_Guild].go_MemberList,i);
	end
	GuildOrg_Debug("Table size: "..table.getn(go_RealmRef[go_Real].go_GuildList[go_Guild].go_MemberList),"blue");
end


function GuildOrg_ClearChecks()
--------------------
-- Clears the checked boxes and checked players.
--------------------
	
	for i=1,go_numGuildMembers,1 do
		go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[i].f_checked = 0;
	end
	
	for i=1,GO_GUILDMEMBERS_TO_DISPLAY,1 do
		getglobal("GuildOrgCheckButton"..i):SetChecked(false);
	end
end


function GuildOrg_NoteCheck(eval_row)
--------------------
-- Used by auto combine, checks the list for alts in either the public list or the officer list.
--------------------	
	
	if(GuildOrgCP_CheckStates.auto_public == 1)then
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_note == nil or string.len(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_note) < 2) then
			GuildOrg_Debug("Public note failed");
			--Too Short or nil, try officer next
		else
			local go_string = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_note;
			--First word
			local go_refined = gsub(go_string, "%s*([^%s]+).*", "%1");
			--Remove any "'s"
			go_string = gsub(go_string,"%p%a", "");
			--Store the rest of the string
			go_string = gsub(go_string, "%s*([^%s]+)%s*(.*)", "%2");
			GuildOrg_Debug("'"..go_refined.."'","black");
			local go_row = GuildOrg_CheckForEntry(go_refined);
			if(go_row>0)then
				GuildOrg_Debug("Found! Setting alt information","green");
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_alt = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name;
				GuildOrg_Print("Match found. Setting "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name.." as the main of "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_name);
				return 1;
			end
			--Try the rest of the string
			local i=1;
			while( string.len(go_string) > 0 and i < 8)  do
				--First word
				go_refined = gsub(go_string, "%s*([^%s]+).*", "%1");
				--Remove any "'s"
				go_string = gsub(go_string,"%p%a", "");
				--Store the rest of the string
				go_string = gsub(go_string, "%s*([^%s]+)%s*(.*)", "%2");
				GuildOrg_Debug("'"..go_refined.."'","black");
				go_row = GuildOrg_CheckForEntry(go_refined);
				if(go_row>0)then
					GuildOrg_Debug("Found! Setting alt information","green");
					go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_alt = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name;
					GuildOrg_Print("Match found. Setting "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name.." as the main of "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_name);
					return 1;
				end
				i=i+1;
			end
		end
	end
	if(GuildOrgCP_CheckStates.auto_officer == 1)then
		if(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_officernote == nil or string.len(go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_officernote) < 2) then
			GuildOrg_Debug("Officer note failed");
			--Too Short or nil, it fails
		else
			local go_string = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_officernote;
			--First word
			local go_refined = gsub(go_string, "%s*([^%s]+).*", "%1");
			--Remove any "'s"
			go_string = gsub(go_string,"%p%a", "");
			--Store the rest of the string
			go_string = gsub(go_string, "%s*([^%s]+)%s*(.*)", "%2");
			GuildOrg_Debug("'"..go_refined.."'","black");
			local go_row = GuildOrg_CheckForEntry(go_refined);
			if(go_row>0)then
				GuildOrg_Debug("Found! Setting alt information","green");
				go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_alt = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name;
				GuildOrg_Print("Match found. Setting "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name.." as the main of "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_name);
				return 1;
			end
			--Try the rest of the string
			local i=1;
			while( string.len(go_string) > 0 and i < 8)  do
				--First word
				go_refined = gsub(go_string, "%s*([^%s]+).*", "%1");
				--Remove any "'s"
				go_string = gsub(go_string,"%p%a", "");
				--Store the rest of the string
				go_string = gsub(go_string, "%s*([^%s]+)%s*(.*)", "%2");
				GuildOrg_Debug("'"..go_refined.."'","black");
				go_row = GuildOrg_CheckForEntry(go_refined);
				if(go_row>0)then
					GuildOrg_Debug("Found! Setting alt information","green");
					go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_alt = go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name;
					GuildOrg_Print("Match found. Setting "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[go_row].f_name.." as the main of "..go_RealmRef[go_Realm].go_GuildList[go_guildName].go_MemberList[eval_row].f_name);
					return 1;
				end
				i=i+1;
			end
		end
	end
	return 0;
end


--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
------------------------  GuildOrg Scroll Bar Section  -------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------


function GuildOrg_ScrollFrame_Update(go_frame, go_numItems, go_numToDisplay, go_valueStep)
	-- If more than one screen full of skills then show the scrollbar
	local go_frameName = go_frame:GetName();
	local go_scrollBar = getglobal( go_frameName.."ScrollBar" );
	local go_showScrollBar;
	GuildOrg_Debug("go_frameName "..go_frameName..", go_numItems "..go_numItems..", go_numToDisplay "..go_numToDisplay..", go_valueStep "..go_valueStep..", go_NumAltsTotal "..go_NumAltsTotal..", mains "..(go_numGuildMembers-go_NumAltsTotal),"white");
	
	if ( go_numItems > go_numToDisplay ) then
		go_frame:Show();
		go_showScrollBar = 1;
		GuildOrg_Debug("Scroll shown");
	else
		go_frame:Hide();
		GuildOrg_Debug("Scroll hidden");
	end
	
	if ( go_frame:IsVisible() ) then
		GuildOrg_Debug("Scroll visible, updating");
		local go_scrollChildFrame = getglobal( go_frameName.."ScrollChildFrame" );
		local go_scrollUpButton = getglobal( go_frameName.."ScrollBarScrollUpButton" );
		local go_scrollDownButton = getglobal( go_frameName.."ScrollBarScrollDownButton" );
		local go_scrollFrameHeight = 0;
		local go_scrollChildHeight = 0;
			
		go_scrollFrameHeight = (go_numItems - go_numToDisplay) * go_valueStep;
		go_scrollChildHeight = go_numItems * go_valueStep;
		if ( go_scrollFrameHeight < 0 ) then
			go_scrollFrameHeight = 0;
		end
		go_scrollChildFrame:Show();
		go_scrollBar:SetMinMaxValues(0, go_scrollFrameHeight); 
		go_scrollBar:SetValueStep(go_valueStep);
		go_scrollChildFrame:SetHeight(go_scrollChildHeight);
	
		-- Arrow button handling
		if ( go_scrollBar:GetValue() == 0 ) then
			go_scrollUpButton:Disable();
		else
		go_scrollUpButton:Enable();
		end
		if ((go_scrollBar:GetValue() - go_scrollFrameHeight) == 0) then
			go_scrollDownButton:Disable();
		else
			go_scrollDownButton:Enable();
		end
	end
	return go_showScrollBar;
end


function GuildOrg_ScrollFrame_GetOffset(go_frame)
	return go_frame.offset;
end


function GuildOrg_ScrollFrame_OnVerticalScroll(go_itemHeight, go_updateFunction)
	local go_scrollbar = getglobal(this:GetName().."ScrollBar");
	go_scrollbar:SetValue(arg1);
	this.offset = floor((arg1 / go_itemHeight) + 0.5);
	go_updateFunction();
end